$(document).ready(function()
{
    let chart;

    function formateaFecha(durationInMinutes) // recibe los minutos y devuelve la hora de inicio
    {
        var startdate = new Date();
        var fecha=startdate.setMinutes(startdate.getMinutes() - durationInMinutes);
        var year=startdate.toLocaleString("default", { year: "numeric" });
        var month=startdate.toLocaleString("default", { month: "2-digit" });
        var day=startdate.toLocaleString("default", { day: "2-digit" });
        var hour=startdate.toLocaleString("default", { hour: "2-digit" });
        var minute=startdate.toLocaleString("default", { minute: "2-digit" });
        minute=("0" + minute).slice(-2);
        var second=startdate.toLocaleString("default", { second: "2-digit" });
        second=("0" + second).slice(-2);
        fecha=year+ "-" + month + "-" +day+" "+hour+":"+minute+":"+second;
        return fecha;
    }

    function formatDate(dateObj,format) //formatea el objeto fecha al formato necesario, el parametro format selecciona el formato necesario
    {
        var monthNames = [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ];
        var curr_date = dateObj.getDate();
        var curr_month = dateObj.getMonth();
        curr_month = curr_month + 1;
        var curr_year = dateObj.getFullYear();
        var curr_min = dateObj.getMinutes();
        var curr_hr= dateObj.getHours();
        var curr_sc= dateObj.getSeconds();
        if(curr_month.toString().length == 1)
        curr_month = '0' + curr_month;
        if(curr_date.toString().length == 1)
        curr_date = '0' + curr_date;
        if(curr_hr.toString().length == 1)
        curr_hr = '0' + curr_hr;
        if(curr_min.toString().length == 1)
        curr_min = '0' + curr_min;

        if(format ==1)//dd-mm-yyyy
        {
            return curr_date + "-"+curr_month+ "-"+curr_year;
        }
        else if(format ==2)//yyyy-mm-dd
        {
            return curr_year + "-"+curr_month+ "-"+curr_date;
        }
        else if(format ==3)//dd/mm/yyyy
        {
            return curr_date + "/"+curr_month+ "/"+curr_year;
        }
        else if(format ==4)// MM/dd/yyyy HH:mm:ss
        {
            return curr_year+"-"+curr_month +"-"+curr_date+ " "+curr_hr+":"+curr_min+":00";
        }
    }

    function urlFiltrado(fecha_inicio,result1,result2,result13,result27,mayorFecha,menorFecha)// formatea y llena el chart
    {
        const ctx = document.getElementById('myChart');
        const data =
        {
            datasets:
            [
                {
                    label: 'LOS',
                    data: result1,//se mueve en el eje y,
                    backgroundColor: 'red',
                    borderColor:'red'
                },
                {
                    label: 'LOSI',
                    data: result2,
                    backgroundColor: 'orange',
                    borderColor:'orange'
                },
                {
                    label: 'GASP',
                    data: result13,
                    backgroundColor: 'yellow',
                    borderColor:'yellow'
                },
                {
                    label: 'ROUGUE',
                    data: result27,
                    backgroundColor: '#8000ff',
                    borderColor:'#8000ff'
                }
            ]
        };

        var colorLetraGrafico='black';

        Chart.defaults.color = colorLetraGrafico;
        if (chart) {
            chart.destroy();
        }

        chart = new Chart(ctx, {
            type: 'line',
            data: data,
            options:
            {
                responsive: true,
                interaction:
                {
                    intersect: true,
                },
                scales:
                {
                    x:
                    {
                        beginAtZero:true,
                        type:'time',
                        time:
                        {
                            minUnit: 'hour',
                            displayFormats: {
                                hour:'dd/MM/yy H:mm',
                            },
                        },
                        suggestedMax: mayorFecha,//debe ser ultimo día más 3 días
                        suggestedMin: menorFecha
                    },
                    y:
                    {
                        beginAtZero:true,
                        ticks:
                        {
                            beginAtZero:true,
                            min: 0,
                            max: 100,
                            precision: 0
                        },
                    },
                },
                elements: {
                    point:
                    {
                        radius: 4
                    },
                    line:
                    {
                        tension: 0 // disables bezier curves
                    }
                },
                plugins:
                {
                    legend:
                    {
                        display: false//para mostrar los botones del filtrado de los tipos de errores
                    },
                    zoom:
                    {
                        limits:
                        {
                            // x: {
                            //     min: 'original', max: 'original', minRange: 60 * 1000
                            // },
                        },
                        zoom:
                        {
                            pan:
                            {
                                enabled: true,
                                mode: 'xy',
                            },
                            drag:
                            {
                                enabled: true,
                            },
                            mode: 'x', // Allow zooming in the x direction
                            wheel:
                            {
                                enabled: true,
                                speed: 0.05,
                            },
                            pinch:
                            {
                                enabled: true
                            },
                        },
                    },
                },
            }
        });

        chart.update();

        fecha_ini=new Date();
        var year=fecha_ini.toLocaleString("default", { year: "numeric" });
        var month=fecha_ini.toLocaleString("default", { month: "2-digit" });
        var day=fecha_ini.toLocaleString("default", { day: "2-digit" });
        var hour=fecha_ini.toLocaleString("default", { hour: "2-digit" });
        var minute=fecha_ini.toLocaleString("default", { minute: "2-digit" });
        minute=("0" + minute).slice(-2);
        var second=fecha_ini.toLocaleString("default", { second: "2-digit" });
        second=("0" + second).slice(-2);
        fecha_actual=year+ "-" + month + "-" +day+" "+hour+":"+minute+":"+second;

        olt=$("#olt").val();

        // traerDatos(fecha_inicio,fecha_actual,'LOS,LOSI,DYING GASP,ROUGUE',olt);
    }

    function traerDatosAll() // trae todos los datos para la tabla, se usa en el reset, borrar Filtros
    {
        $(".spinner-box").show();
        $.ajax({
            url:"/logoid/obtenerLogOid",
            type:'post',
            datatype:'json',
            // async: false,
        }).done(function(response)
        {
            var oTable=$('#tablalogoids').DataTable({
                dom: 'Bfrtip',
                buttons: [
                    { extend: 'csv', text: 'Exportar Filtrado', className: ''}
                ],
                destroy:true,
                data: [],
                columns:[
                    {data:"CANT"},
                    {data:"SERIALNUMBER"},
                    {data:"OLT"},
                    {data:"PLACA"},
                    {data:"PUERTO"},
                    {data:"NOMBRE_ERROR"},
                    {data:"DATETIME"}
                ],
                "bDestroy": true,
                "aoColumnDefs": [
                    {
                        "aTargets": [ 1 ], // Column to target
                        "mRender": function ( data, type, full ) {
                            if (!full["ID_CLIENTE_PLAN"]) {
                                return data;
                            }
                            else
                            {
                                var windowurl = window.location.href;
                                var baseUrl=windowurl.split('://')[1].split('/')[0];
                                return '<a href="https://'+baseUrl+'/diagnostico_red/diagnostico_red.php?idCliente=' + full["ID_CLIENTE_PLAN"] + '" target="_blank">' + data + '</a>';
                            }
                            // 'full' is the row's data object, and 'data' is this column's data
                            // e.g. 'full[0]' is the comic id, and 'data' is the comic title
                        }
                    }
                ]
            });
            // oTable.destroy();
            const datos = JSON.parse(response);
            oTable.clear().draw();
            oTable.rows.add(datos).draw(true);
            // fin de carga de datos dataTable

            collapsedGroups = {};
            var j=0;
            var oTable = $('#tablalogoids').DataTable({
                dom: 'Blfrtip',
                buttons: [
                    { extend: 'csv', text: 'Exportar a CSV', className: ''}
                ],
                destroy:true,
                orderFixed: {
                    //para ordenar las filas sin romper los contenedores que colapsan las filas
                    "pre": [[ 1, 'asc' ], [ 5, 'asc' ]]
                },
                pageLength: 25,
                paging: true,
                language: {
                    "decimal": "",
                    "emptyTable": "No hay informaci&oacute;n",
                    "info": "Mostrando _START_ a _END_ de _TOTAL_ Entradas",
                    "infoEmpty": "Mostrando 0 a 0 de 0 Entradas",
                    "infoFiltered": "(Filtrado de _MAX_ total entradas)",
                    "infoPostFix": "",
                    "thousands": ",",
                    "lengthMenu": "Mostrar _MENU_ ",
                    "loadingRecords": "Cargando...",
                    "processing": "Procesando...",
                    "search": "Buscar:",
                    "zeroRecords": "Sin resultados encontrados",
                    "paginate": {
                        "first": "Primero",
                        "last": "Ultimo",
                        "next": "Siguiente",
                        "previous": "Anterior"
                    }
                },
                responsive: true,
                responsive:
                {
                    details:
                    {
                        type: 'column',
                        target: 'tr'
                    }
                },

                order: [
                    [1, 'asc']
                ],
                'select': {
                    'style': 'single'
                },
                    'processing': true,
                    "autoWidth": true,
                    "lengthMenu": [
                        [15, 20, 50, 100, 500, -1],
                        [15, 20, 50, 100, 500, "Todo"]
                    ],
                    "iDisplayLength": 25,
                rowGroup:
                {
                    // Uses the 'row group' plugin
                    dataSrc: 1,
                    startRender: function(rows, group)
                    {
                        var collapsed = !!collapsedGroups[group];
                        rows.nodes().each(function(r) {
                            r.style.display = 'none';
                            if (collapsed)
                            {
                                r.style.display = '';
                            }
                        });
                        // estado_ont=rows.nodes()[0].cells[2].firstChild.data;

                        if (rows.nodes()[0].cells[2].firstChild==null)
                        {
                            olt='';
                        }
                        else
                        {
                            olt=rows.nodes()[0].cells[2].firstChild.data;
                        }

                        if (rows.nodes()[0].cells[3].firstChild==null)
                        {
                            placa='';
                        }
                        else
                        {
                            placa=rows.nodes()[0].cells[3].firstChild.data;
                        }

                        if (rows.nodes()[0].cells[4].firstChild==null)
                        {
                            puerto='';
                        }
                        else
                        {
                            puerto=rows.nodes()[0].cells[4].firstChild.data;
                        }
                        valor_ultima_caida=rows.nodes()[0].cells[5].firstChild.data;
                        datetime=rows.nodes()[0].cells[6].firstChild.data;

                        // Add category name to the <tr>. NOTE: Hardcoded colspan
                        j++;

                        if(j%2==0)
                        {
                            clase='trPar';
                        }
                        else
                        {
                            clase='trImpar';
                        }
                        if (rows.count()>1)
                        {
                            return $('<tr class="'+clase+' group-start"/> ')
                            .append('<td>'+rows.count()+' <svg class="svgEstilo" xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-down" viewBox="0 0 16 16"><path fill-rule="evenodd" d="M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z"/></svg></td><td>' + group +'</td><td>'+olt+'</td><td>'+placa+'</td><td>'+puerto+'</td><td>'+valor_ultima_caida+' </td><td> '+datetime+' </td>')
                            .attr('data-name', group)
                            .toggleClass('collapsed', collapsed);
                        }
                        else{
                            return $('<tr class="'+clase+'" /> ')
                            .append('<td></td><td>' + group +'</td><td>'+olt+'</td><td>'+placa+'</td><td>'+puerto+'</td><td>'+valor_ultima_caida+' </td><td> '+datetime+' </td>')
                        }
                    }
                },
                "bDestroy": true
            });
            $('#tablalogoids tbody').off().on('click', 'tr.group-start', function() {
                var name = $(this).data('name');
                collapsedGroups[name] = !collapsedGroups[name];
                oTable.draw(false);
            });
            $(".spinner-box").hide();
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    }

    function traerDatos(fecha_inicio,fecha_fin,filtro,olt) // formatea la tabla y llama a updateChart()
    {
        olt=$( "#olt" ).val();
        $(".spinner-box").show();
        $.ajax({
            url:"/logoid/obtenerLogOidFechas",
            type:'post',
            datatype:'json',
            // async: false,
            data:{
                fecha_ini:fecha_inicio,
                fecha_fin:fecha_fin,
                filtro:filtro,
                olt:olt
            },
        }).done(function(response)
        {
            // const d = new Date(fecha_ini);
            // $('#tablalogoids').DataTable({destroy: true}).draw();
            var oTable=$('#tablalogoids').DataTable({
                dom: 'Bfrtip',
                buttons: [
                    { extend: 'csv', text: 'Exportar Filtrado', className: ''}
                ],
                destroy:true,
                data: [],
                columns:[
                    {data:"CANT"},
                    {data:"SERIALNUMBER"},
                    {data:"OLT"},
                    {data:"PLACA"},
                    {data:"PUERTO"},
                    {data:"NOMBRE_ERROR"},
                    {data:"DATETIME"},
                ],
                "bDestroy": true,
                "aoColumnDefs": [
                    {
                        "aTargets": [ 1 ], // Column to target
                        "mRender": function ( data, type, full ) {
                            // 'full' is the row's data object, and 'data' is this column's data
                            // e.g. 'full[0]' is the comic id, and 'data' is the comic title
                            if (!full["ID_CLIENTE_PLAN"]) {
                                return data;
                            }
                            else
                            {
                                var windowurl = window.location.href;
                                var baseUrl=windowurl.split('://')[1].split('/')[0];
                                return '<a href="https://'+baseUrl+'/diagnostico_red/diagnostico_red.php?idCliente=' + full["ID_CLIENTE_PLAN"] + '" target="_blank">' + data + '</a>';
                            }

                        }
                    }
                ]
            });
            // oTable.destroy();
            const datos = JSON.parse(response);
            oTable.clear().draw();
            oTable.rows.add(datos).draw(true);
            // fin de carga de datos dataTable

            collapsedGroups = {};
            var j=0;
            var oTable = $('#tablalogoids').DataTable({
                dom: 'Blfrtip',
                buttons: [
                    { extend: 'csv', text: 'Exportar a CSV', className: ''}
                ],
                destroy:true,
                orderFixed: {
                    //para ordenar las filas sin romper los contenedores que colapsan las filas
                    "pre": [[ 1, 'asc' ], [ 5, 'asc' ]]
                },
                pageLength: 25,
                paging: true,
                language: {
                    "decimal": "",
                    "emptyTable": "No hay informaci&oacute;n",
                    "info": "Mostrando _START_ a _END_ de _TOTAL_ Entradas",
                    "infoEmpty": "Mostrando 0 a 0 de 0 Entradas",
                    "infoFiltered": "(Filtrado de _MAX_ total entradas)",
                    "infoPostFix": "",
                    "thousands": ",",
                    "lengthMenu": "Mostrar _MENU_ ",
                    "loadingRecords": "Cargando...",
                    "processing": "Procesando...",
                    "search": "Buscar:",
                    "zeroRecords": "Sin resultados encontrados",
                    "paginate": {
                        "first": "Primero",
                        "last": "Ultimo",
                        "next": "Siguiente",
                        "previous": "Anterior"
                    }
                },
                responsive: true,
                responsive:
                {
                    details:
                    {
                        type: 'column',
                        target: 'tr'
                    }
                },
                order: [
                    [1, 'asc']
                ],
                'select': {
                    'style': 'single'
                },
                    'processing': true,
                    "autoWidth": true,
                    "lengthMenu": [
                        [15, 20, 50, 100, 500, -1],
                        [15, 20, 50, 100, 500, "Todo"]
                    ],
                    "iDisplayLength": 25,
                rowGroup:
                {
                    // Uses the 'row group' plugin
                    dataSrc: 1,
                    startRender: function(rows, group)
                    {
                        var collapsed = !!collapsedGroups[group];
                        rows.nodes().each(function(r) {
                            r.style.display = 'none';
                            if (collapsed)
                            {
                                r.style.display = '';
                            }
                        });
                        // estado_ont=rows.nodes()[0].cells[2].firstChild.data;

                        if (rows.nodes()[0].cells[2].firstChild==null)
                        {
                            olt='';
                        }
                        else
                        {
                            olt=rows.nodes()[0].cells[2].firstChild.data;
                        }

                        if (rows.nodes()[0].cells[3].firstChild==null)
                        {
                            placa='';
                        }
                        else
                        {
                            placa=rows.nodes()[0].cells[3].firstChild.data;
                        }

                        if (rows.nodes()[0].cells[4].firstChild==null)
                        {
                            puerto='';
                        }
                        else
                        {
                            puerto=rows.nodes()[0].cells[4].firstChild.data;
                        }

                        valor_ultima_caida=rows.nodes()[0].cells[5].firstChild.data;
                        datetime=rows.nodes()[0].cells[6].firstChild.data;

                        // Add category name to the <tr>. NOTE: Hardcoded colspan
                        j++;

                        if(j%2==0)
                        {
                            clase='trPar';
                        }
                        else
                        {
                            clase='trImpar';
                        }
                        if (rows.count()>1)
                        {
                            return $('<tr class="'+clase+' group-start"/> ')
                            .append('<td>'+rows.count()+' <svg class="svgEstilo" xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-down" viewBox="0 0 16 16"><path fill-rule="evenodd" d="M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z"/></svg></td><td>' + group +'</td><td>'+olt+'</td><td>'+placa+'</td><td>'+puerto+'</td><td>'+valor_ultima_caida+' </td><td> '+datetime+' </td>')
                            .attr('data-name', group)
                            .toggleClass('collapsed', collapsed);
                        }
                        else{
                            return $('<tr class="'+clase+'" /> ')
                            .append('<td></td><td>' + group +'</td><td>'+olt+'</td><td>'+placa+'</td><td>'+puerto+'</td><td>'+valor_ultima_caida+' </td><td> '+datetime+' </td>')
                        }
                    }
                },
                "bDestroy": true
            });

            $('#tablalogoids tbody').off().on('click', 'tr.group-start', function() {
                var name = $(this).data('name');
                collapsedGroups[name] = !collapsedGroups[name];
                oTable.draw(false);
            });
            $(".spinner-box").hide();
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    }

    $('.buscar_datos').click(function()
    {
        // $(".spinner-box").show();
        let fecha_ini=chart.scales.x.ticks[0].label;
        let ff=chart.scales.x.ticks[0].value;
        fecha_ini=new Date(ff);

        var year=fecha_ini.toLocaleString("default", { year: "numeric" });
        var month=fecha_ini.toLocaleString("default", { month: "2-digit" });
        var day=fecha_ini.toLocaleString("default", { day: "2-digit" });
        var hour=fecha_ini.toLocaleString("default", { hour: "2-digit" });
        var minute=fecha_ini.toLocaleString("default", { minute: "2-digit" });
        minute=fecha_ini.getMinutes();
        minute=("0" + minute).slice(-2);

        var second=fecha_ini.toLocaleString("default", { second: "2-digit" });
        second=("0" + second).slice(-2);
        // Generate yyyy-mm-dd date string
        fecha_ini=year+ "-" + month + "-" +day+" "+hour+":"+minute+":"+second;

        var dato=chart.scales.x.ticks;
        let fecha_fin=chart.scales.x.ticks[dato.length - 1].$context.tick.value;
        fecha_fin=new Date(fecha_fin);
        year=fecha_fin.toLocaleString("default", { year: "numeric" });
        month=fecha_fin.toLocaleString("default", { month: "2-digit" });
        day=fecha_fin.toLocaleString("default", { day: "2-digit" });
        hour=fecha_fin.toLocaleString("default", { hour: "2-digit" });
        minute=fecha_fin.toLocaleString("default", { minute: "2-digit" });
        minute=("0" + minute).slice(-2);

        second=fecha_fin.toLocaleString("default", { second: "2-digit" });
        second=("0" + second).slice(-2);
        fecha_fin=year+ "-" + month + "-" + day+" "+hour+":"+minute+":"+second;

        let filtros='';
        var nombre='estadoOid.php';
        $('.casilla').each(function() {
            switch ($(this)[0].value) {
                case '0':
                    nombre='LOS';
                    break;
                case '1':
                    nombre='LOSI';
                    break;
                case '2':
                    nombre='DYING GASP';
                    break;
                case '3':
                    nombre='ROUGUE';
                    break;
                default:
                    // statements_def
                    break;
            }
            if($(this).prop('checked')) {
                filtros+=nombre +',';
            }
        });
        filtros=filtros.slice(0, -1);
        olt=$("#olt").val();
        updateChart();
        traerDatos(fecha_ini,fecha_fin,filtros,olt);
        // $(".spinner-box").hide();
    });

    function updateChart()
    {
        let filtros='';
        var nombre='';
        $('.casilla').each(function() {
            switch ($(this)[0].value) {
                case '0':
                    nombre='LOS';
                    break;
                case '1':
                    nombre='LOSI';
                    break;
                case '2':
                    nombre='DYING GASP';
                    break;
                case '3':
                    nombre='ROUGUE';
                    break;
                default:
                    // statements_def
                    break;
            }
            if ($(this).prop('checked')) {
                filtros+=nombre +',';
            }
        });
        filtros=filtros.slice(0, -1);

        let fecha_ini=chart.scales.x.ticks[0].label;
        let ff=chart.scales.x.ticks[0].value;
        fecha_ini=new Date(ff);

        var year = fecha_ini.toLocaleString("default", { year: "numeric" });
        var month = fecha_ini.toLocaleString("default", { month: "2-digit" });
        var day = fecha_ini.toLocaleString("default", { day: "2-digit" });
        // Generate yyyy-mm-dd date string
        fecha_ini=year+ "-" + month + "-" + day;
        var dato=chart.scales.x.ticks;
        let fecha_fin=chart.scales.x.ticks[dato.length - 1].$context.tick.value;
        let fecha_ini_ok=formatDate(new Date(ff),4);
        let fecha_fin_ok=formatDate(new Date(fecha_fin),4);//fecha extraida de label del chart

        fecha_fin=new Date(fecha_fin);
        year=fecha_fin.toLocaleString("default", { year: "numeric" });
        month=fecha_fin.toLocaleString("default", { month: "2-digit" });
        day=fecha_fin.toLocaleString("default", { day: "2-digit" });
        fecha_fin=year+ "-" + month + "-" + day;

        olt=$("#olt").val();

        $.ajax({
            url:"/logoid/datosGrafico",
            type:'post',
            datatype:'json',
            data:{
                fecha_ini:fecha_ini_ok,
                fecha_fin:fecha_fin_ok,
                filtro:filtros,
                olt:olt
            },
        }).done(function(response)
        {
            var obj={};
            result1=[];
            result2=[];
            result13=[];
            result27=[];
            datos=JSON.parse(response);

            $.each(datos, function (i) {
                obj['x']=new Date(datos[i]['fecha']);
                obj['y']=datos[i]['Cantidad'];

                switch (datos[i]['TIPO']) {
                    case 'LOS':
                        result1.push(obj);
                        break;
                    case 'LOSI':
                        result2.push(obj);
                        break;
                    case 'DYING GASP':
                        result13.push(obj);
                        break;
                    case 'ROUGUE':
                        result27.push(obj);
                        break;
                    default:
                        break;
                }
                obj={};
            })

            data2 =
            {
                datasets:
                [
                    {
                        label: 'LOS',
                        data: result1,//se mueve en el eje y,
                        backgroundColor: 'red',
                        borderColor:'red'
                    },
                    {
                        label: 'LOSI',
                        data: result2,
                        backgroundColor: 'orange',
                        borderColor:'orange'
                    },
                    {
                        label: 'GASP',
                        data: result13,
                        backgroundColor: 'yellow',
                        borderColor:'yellow'
                    },
                    {
                        label: 'ROUGUE',
                        data: result27,
                        backgroundColor: '#8000ff',
                        borderColor:'#8000ff'
                    }
                ]
            };
            chart.config.data=data2;
            chart.update();
            ////////

            let fecha_ini=chart.scales.x.ticks[0].label;
            let ff=chart.scales.x.ticks[0].value;
            fecha_ini=new Date(ff);

            var year=fecha_ini.toLocaleString("default", { year: "numeric" });
            var month=fecha_ini.toLocaleString("default", { month: "2-digit" });
            var day=fecha_ini.toLocaleString("default", { day: "2-digit" });
            var hour=fecha_ini.toLocaleString("default", { hour: "2-digit" });
            var minute=fecha_ini.toLocaleString("default", { minute: "2-digit" });
            minute=("0" + minute).slice(-2);
            var second=fecha_ini.toLocaleString("default", { second: "2-digit" });
            second=("0" + second).slice(-2);
            // Generate yyyy-mm-dd date string
            fecha_ini=year+ "-" + month + "-" +day+" "+hour+":"+minute+":"+second;

            var dato=chart.scales.x.ticks;
            let fecha_fin=chart.scales.x.ticks[dato.length - 1].$context.tick.value;
            fecha_fin=new Date(fecha_fin);

            year=fecha_fin.toLocaleString("default", { year: "numeric" });
            month=fecha_fin.toLocaleString("default", { month: "2-digit" });
            day=fecha_fin.toLocaleString("default", { day: "2-digit" });
            hour=fecha_fin.toLocaleString("default", { hour: "2-digit" });
            minute=fecha_fin.toLocaleString("default", { minute: "2-digit" });
            minute=("0" + minute).slice(-2);
            second=fecha_fin.toLocaleString("default", { second: "2-digit" });
            second=("0" + second).slice(-2);
            fecha_fin=year+ "-" + month + "-" + day+" "+hour+":"+minute+":"+second;

            fecha_ini=new Date(fecha_ini);
            fecha_fin=new Date(fecha_fin);
            var totalt=0;
            var all_lines=chart.data.datasets;

            $.each(all_lines, function( index, value ) {
                $.each(value.data, function( i, valu ) {
                    fecha_punto=new Date(valu.x);
                    if (fecha_punto.getTime()>fecha_ini.getTime() && fecha_punto.getTime()<fecha_fin.getTime())
                    {
                        totalt+=Number(valu.y);
                    }
                });

                // switch (index+1) {
                //     case 1:
                //         $("#cantidad_los").html(totalt);
                //         break;
                //     case 2:
                //         $("#cantidad_losi").html(totalt);
                //         break;
                //     case 3:
                //         $("#cantidad_gasp").html(totalt);
                //         break;
                //     case 4:
                //         $("#cantidad_rougue").html(totalt);
                //         break;
                //     default:
                //         // statements_def
                //         break;
                // }
                totalt=0;
            });

            $.ajax({
                url:"/logoid/datosGraficoParaRecuadro",
                type:'post',
                datatype:'json',
                // async: false,
                data:{
                    fecha_ini:fecha_ini_ok,
                    fecha_fin:fecha_fin_ok,
                    filtro:filtro,
                    olt:olt,
                },
            }).done(function(response_2)
            {
                var mayorFecha=new Date(fecha_fin);
                var menorFecha=new Date(fecha_ini);

                datosGraf=JSON.parse(response_2);

                if (datosGraf.length==0) {
                    alert("No hay datos en el rango seleccionado");
                    mayorFecha=new Date('2023-01-01');
                    menorFecha=new Date('2023-12-01');
                }
                contador_los=0;
                contador_losi=0;
                contador_gasp=0;
                contador_rougue=0;
                $.each(datosGraf, function (i) {

                    switch (datosGraf[i]['TIPO']) {
                        case 'LOS':
                            contador_los+=Number(datosGraf[i]['Cantidad']);
                            break;
                        case 'LOSI':
                            contador_losi+=Number(datosGraf[i]['Cantidad']);
                            break;
                        case 'DYING GASP':
                            contador_gasp+=Number(datosGraf[i]['Cantidad']);
                            break;
                        case 'ROUGUE':
                            contador_rougue+=Number(datosGraf[i]['Cantidad']);
                            break;
                        default:
                            break;
                    }
                    obj={};
                })
                $("#cantidad_los").html(contador_los);
                $("#cantidad_losi").html(contador_losi);
                $("#cantidad_gasp").html(contador_gasp);
                $("#cantidad_rougue").html(contador_rougue);
            })
            .fail(function (jqXHR, textStatus, errorThrown){
                alert("" + jqXHR + textStatus +errorThrown);
            });
            // $(".spinner-box").hide();
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        })
    }

    $("#tablalogoids").removeClass("no-footer");

    $(document).mousemove(function(e)
    {
        var mouseX = e.pageX;
        var mouseY = e.pageY;
        $('.pop-over').css
        ({
            top: mouseY - 250,
            left: mouseX - 100
        });
    });

    $(".botonResetFiltros").click(function() // para borrar los filtros y resetear el mapa
    {
        // $(".spinner-box").show();
        $('.casilla').prop('checked', true);
        chart.resetZoom();
        $('#olt').prop('selectedIndex',0);
        //tiene que traer todos los datos disponibles

        var elemento;
        var obj={};
        var result1=[];
        var result2=[];
        var result13=[];
        var result27=[];
        var contador_los=0;
        var contador_losi=0;
        var contador_gasp=0;
        var contador_rougue=0;

        datosGraf=<?php echo json_encode($this->datosGrafico);?>;

        var mayorFecha=new Date('1990-01-01').getTime();
        var menorFecha=new Date('2300-01-01').getTime();

        $.each(datosGraf, function (i) {
            obj['x']=new Date(datosGraf[i]['fecha']);

            if (obj['x']>mayorFecha)
            {
                mayorFecha=obj['x'];
            }
            if (obj['x']<menorFecha)
            {
                menorFecha=obj['x'];
            }
            obj['y']=datosGraf[i]['Cantidad'];
            switch (datosGraf[i]['TIPO']) {
                case 'LOS':
                    result1.push(obj);
                    contador_los+=Number(datosGraf[i]['Cantidad']);
                    break;
                case 'LOSI':
                    result2.push(obj);
                    contador_losi+=Number(datosGraf[i]['Cantidad']);
                    break;
                case 'DYING GASP':
                    result13.push(obj);
                    contador_gasp+=Number(datosGraf[i]['Cantidad']);
                    break;
                case 'ROUGUE':
                    result27.push(obj);
                    contador_rougue+=Number(datosGraf[i]['Cantidad']);
                    break;
                default:
                    break;
            }
            obj={};
        })

        mayorFecha=mayorFecha.addDays(4);
        menorFecha=menorFecha.subsDays(4);

        $("#cantidad_los").html(contador_los);
        $("#cantidad_losi").html(contador_losi);
        $("#cantidad_gasp").html(contador_gasp);
        $("#cantidad_rougue").html(contador_rougue);

        const ctx = document.getElementById('myChart');
        const data =
        {
            datasets:
            [
                {
                    label: 'LOS',
                    data: result1,//se mueve en el eje y,
                    backgroundColor: 'red',
                    borderColor:'red'
                },
                {
                    label: 'LOSI',
                    data: result2,
                    backgroundColor: 'orange',
                    borderColor:'orange'
                },
                {
                    label: 'GASP',
                    data: result13,
                    backgroundColor: 'yellow',
                    borderColor:'yellow'
                },
                {
                    label: 'ROUGUE',
                    data: result27,
                    backgroundColor: '#8000ff',
                    borderColor:'#8000ff'
                }
            ]
        };

        var colorLetraGrafico='black';

        Chart.defaults.color = colorLetraGrafico;
        if (chart) {
            chart.destroy();
        }

        chart = new Chart(ctx, {
            type: 'line',
            data: data,
            options:
            {
                responsive: true,
                interaction:
                {
                    intersect: true,
                },
                scales:
                {
                    x:
                    {
                        type:'time',
                        time:
                        {
                            minUnit: 'hour',
                            displayFormats: {
                                hour:'dd/MM/yy H:mm',
                            },
                        },
                        suggestedMax: mayorFecha,//debe ser ultimo día más 3 días
                        suggestedMin: menorFecha
                    },
                    y:
                    {
                        beginAtZero:true,
                        ticks:
                        {
                            beginAtZero:true,
                            min: 0,
                            max: 100,
                            precision: 0
                        },
                    },
                },
                elements: {
                    point:
                    {
                        radius: 4
                    },
                    line:
                    {
                        tension: 0 // disables bezier curves
                    }
                },
                plugins:
                {
                    legend:
                    {
                        display: false//para mostrar los botones del filtrado de los tipos de errores
                    },
                    zoom:
                    {
                        limits:
                        {
                            // x:
                            // {
                            //     min: 'original', max: 'original', minRange: 60 * 1000
                            // },
                        },
                        zoom:
                        {
                            pan:
                            {
                                enabled: true,
                                mode: 'xy',
                            },
                            drag:
                            {
                                enabled: true,
                            },
                            mode: 'x', // Allow zooming in the x direction
                            wheel:
                            {
                                enabled: true,
                                speed: 0.05,
                            },
                            pinch:
                            {
                                enabled: true
                            },
                        },
                    },
                },
            }
        });

        chart.update();
        traerDatosAll();
        // $(".spinner-box").hide();
    });

    $('.resetear').click(function()
    {
        chart.resetZoom();
    })

    Date.prototype.addDays = function(days) {
        var date = new Date(this.valueOf());
        date.setDate(date.getDate() + days);
        return date;
    }

    Date.prototype.subsDays = function(days) {
        var date = new Date(this.valueOf());
        date.setDate(date.getDate() - days);
        return date;
    }

    Date.prototype.addHours= function(h){
        var copiedDate = new Date(this.getTime());
        copiedDate.setHours(copiedDate.getHours()+h);
        return copiedDate;
    }

    Date.prototype.subsHours= function(h){
        var copiedDate = new Date(this.getTime());
        copiedDate.setHours(copiedDate.getHours()-h);
        return copiedDate;
    }
    ///////////////////

    var d=new Date();
    d.setMonth(d.getMonth() - 2);
    d.setMonth(d.getMonth() + 3);
    var todayDate=new Date().toISOString().slice(0, 10);
    var d=new Date(todayDate);
    d.setMonth(d.getMonth() -2);
    fecha_antes=d.toISOString().slice(0, 10)
    var des=new Date(todayDate);
    des.setMonth(des.getMonth() +1);
    fecha_despues=des.toISOString().slice(0, 10);

    const queryString=window.location.search;
    const urlParams=new URLSearchParams(queryString);
    const parametro=urlParams.get('filtrarFechas');
    const caida=urlParams.get('caida');

    if (parametro=='24'||parametro=='15') { // si entra por el parámetro de los 15 minutos o 24 horas "logOid?filtrarFechas=24"
        fecha='';
        switch (parametro) {
            case '24':
                var startdate=new Date();
                var durationInMinutes=1440;
                fecha=formateaFecha(durationInMinutes);
                break;
            case '15':
                var startdate=new Date();
                var durationInMinutes=15;
                fecha=formateaFecha(15);
                break;
            default:
                // statements_def
                break;
        }

        filtro='LOS,LOSI,DYING GASP,ROUGUE';
        switch (caida) {
            case 'los':
                filtro='LOS';
                $("#cb2").prop("checked", false);
                $("#cb3").prop("checked", false);
                $("#cb4").prop("checked", false);
                break;
            case 'losi':
                filtro='LOSI';
                $("#cb1").prop("checked", false);
                $("#cb3").prop("checked", false);
                $("#cb4").prop("checked", false);
                break;
            case 'gasp':
                filtro='DYING GASP';
                $("#cb1").prop("checked", false);
                $("#cb2").prop("checked", false);
                $("#cb4").prop("checked", false);
                break;
            case 'rougue':
                filtro='ROUGUE';
                $("#cb1").prop("checked", false);
                $("#cb2").prop("checked", false);
                $("#cb3").prop("checked", false);
                break;
            default:
                // statements_def
                break;
        }
        //fecha // es la fecha inicial si se toma en cuenta las 24 hs o los 15 minutos

        var elemento;
        var obj={};
        var result1=[];
        var result2=[];
        var result13=[];
        var result27=[];
        var contador_los=0;
        var contador_losi=0;
        var contador_gasp=0;
        var contador_rougue=0;

        var ahora = new Date();//para obtener la fecha actual
        var year=ahora.toLocaleString("default", { year: "numeric" });
        var month=ahora.toLocaleString("default", { month: "2-digit" });
        var day=ahora.toLocaleString("default", { day: "2-digit" });
        var hour=ahora.toLocaleString("default", { hour: "2-digit" });
        var minute=ahora.toLocaleString("default", { minute: "2-digit" });
        minute=("0" + minute).slice(-2);
        var second=ahora.toLocaleString("default", { second: "2-digit" });
        second=("0" + second).slice(-2);
        ahora=year+ "-" + month + "-" +day+" "+hour+":"+minute+":"+second;

        olt=$("#olt").val();

        oltSelect = urlParams.get('Id')
        $.ajax({
            url:"/logoid/datosGrafico",
            type:'post',
            datatype:'json',
            // async: false,
            data:{
                fecha_ini:fecha,
                fecha_fin:ahora,
                filtro:filtro,
                olt:oltSelect,
            },
        }).done(function(response)
        {
            var mayorFecha=new Date('1990-01-01');
            var menorFecha=new Date('2300-01-01');

            datosGraf=JSON.parse(response);

            if (datosGraf.length==0) {
                alert("No hay datos en el rango seleccionado");
                mayorFecha=new Date('2023-01-01');
                menorFecha=new Date('2023-12-01');
            }

            $.each(datosGraf, function (i) {
                obj['x']=new Date(datosGraf[i]['fecha']);
                if (obj['x']>mayorFecha)
                {
                    mayorFecha=obj['x'];
                }
                if (obj['x']<menorFecha)
                {
                    menorFecha=obj['x'];
                }
                obj['y']=datosGraf[i]['Cantidad'];

                switch (datosGraf[i]['TIPO']) {
                    case 'LOS':
                        result1.push(obj);
                        contador_los+=Number(datosGraf[i]['Cantidad']);
                        break;
                    case 'LOSI':
                        result2.push(obj);
                        contador_losi+=Number(datosGraf[i]['Cantidad']);
                        break;
                    case 'DYING GASP':
                        result13.push(obj);
                        contador_gasp+=Number(datosGraf[i]['Cantidad']);
                        break;
                    case 'ROUGUE':
                        result27.push(obj);
                        contador_rougue+=Number(datosGraf[i]['Cantidad']);
                        break;
                    default:
                        break;
                }
                obj={};
            })

            mayorFecha=mayorFecha.addHours(4);
            menorFecha=menorFecha.subsHours(4);

            urlFiltrado(fecha,result1,result2,result13,result27,mayorFecha,menorFecha);
            traerDatos(fecha,ahora,filtro,'');
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });

        oltSelect = urlParams.get('Id')
        $.ajax({
            url:"/logoid/datosGraficoParaRecuadro",
            type:'post',
            datatype:'json',
            // async: false,
            data:{
                fecha_ini:fecha,
                fecha_fin:ahora,
                filtro:filtro,
                olt:oltSelect,
            },
        }).done(function(response_2)
        {
            var mayorFecha=new Date('1990-01-01');
            var menorFecha=new Date('2300-01-01');

            datosGraf=JSON.parse(response_2);

            if (datosGraf.length==0) {
                alert("No hay datos en el rango seleccionado");
                mayorFecha=new Date('2023-01-01');
                menorFecha=new Date('2023-12-01');
            }
            contador_los=0;
            contador_losi=0;
            contador_gasp=0;
            contador_rougue=0;
            $.each(datosGraf, function (i) {

                switch (datosGraf[i]['TIPO']) {
                    case 'LOS':
                        contador_los+=Number(datosGraf[i]['Cantidad']);
                        break;
                    case 'LOSI':
                        contador_losi+=Number(datosGraf[i]['Cantidad']);
                        break;
                    case 'DYING GASP':
                        contador_gasp+=Number(datosGraf[i]['Cantidad']);
                        break;
                    case 'ROUGUE':
                        contador_rougue+=Number(datosGraf[i]['Cantidad']);
                        break;
                    default:
                        break;
                }
            })
            $("#cantidad_los").html(contador_los);
            $("#cantidad_losi").html(contador_losi);
            $("#cantidad_gasp").html(contador_gasp);
            $("#cantidad_rougue").html(contador_rougue);
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    }
    else // fin if filtrarFechas
    {   //cuando entra sin ningun parámetro de tiempo
        var elemento;
        var obj={};
        var result1=[];
        var result2=[];
        var result13=[];
        var result27=[];
        var contador_los=0;
        var contador_losi=0;
        var contador_gasp=0;
        var contador_rougue=0;

        datosGraf=<?php echo json_encode($this->datosGrafico);?>;

        var mayorFecha=new Date('1990-01-01').getTime();
        var menorFecha=new Date('2300-01-01').getTime();

        $.each(datosGraf, function (i) {
            obj['x']=new Date(datosGraf[i]['fecha']);
            if (obj['x']>mayorFecha)
            {
                mayorFecha=obj['x'];
            }
            if (obj['x']<menorFecha)
            {
                menorFecha=obj['x'];
            }
            obj['y']=datosGraf[i]['Cantidad'];
            switch (datosGraf[i]['TIPO']) {
                case 'LOS':
                    result1.push(obj);
                    contador_los+=Number(datosGraf[i]['Cantidad']);
                    break;
                case 'LOSI':
                    result2.push(obj);
                    contador_losi+=Number(datosGraf[i]['Cantidad']);
                    break;
                case 'DYING GASP':
                    result13.push(obj);
                    contador_gasp+=Number(datosGraf[i]['Cantidad']);
                    break;
                case 'ROUGUE':
                    result27.push(obj);
                    contador_rougue+=Number(datosGraf[i]['Cantidad']);
                    break;
                default:
                    break;
            }
            obj={};
        })

        mayorFecha=mayorFecha.addDays(4);
        menorFecha=menorFecha.subsDays(4);

        $("#cantidad_los").html(contador_los);
        $("#cantidad_losi").html(contador_losi);
        $("#cantidad_gasp").html(contador_gasp);
        $("#cantidad_rougue").html(contador_rougue);

        //llamar a datos grafico por ajax pasandole la fecha por parametro de 15 o 24 segun el switch

        const ctx = document.getElementById('myChart');
        const data =
        {
            datasets:
            [
                {
                    label: 'LOS',
                    data: result1,//se mueve en el eje y,
                    backgroundColor: 'red',
                    borderColor:'red'
                },
                {
                    label: 'LOSI',
                    data: result2,
                    backgroundColor: 'orange',
                    borderColor:'orange'
                },
                {
                    label: 'GASP',
                    data: result13,
                    backgroundColor: 'yellow',
                    borderColor:'yellow'
                },
                {
                    label: 'ROUGUE',
                    data: result27,
                    backgroundColor: '#8000ff',
                    borderColor:'#8000ff'
                }
            ]
        };

        var colorLetraGrafico='black';

        Chart.defaults.color = colorLetraGrafico;
        if (chart) {
            chart.destroy();
        }

        chart = new Chart(ctx, {
            type: 'line',
            data: data,
            options:
            {
                responsive: true,
                interaction:
                {
                    intersect: true,
                },
                scales:
                {
                    x:
                    {
                        type:'time',
                        time:
                        {
                            minUnit: 'hour',
                            displayFormats: {
                                hour:'dd/MM/yy H:mm',
                            },
                        },
                        suggestedMax: mayorFecha,//debe ser ultimo día más 3 días
                        suggestedMin: menorFecha
                    },
                    y:
                    {
                        beginAtZero:true,
                        ticks:
                        {
                            beginAtZero:true,
                            min: 0,
                            max: 100,
                            precision: 0
                        },
                    },
                },
                elements: {
                    point:
                    {
                        radius: 4
                    },
                    line:
                    {
                        tension: 0 // disables bezier curves
                    }
                },
                plugins:
                {
                    legend:
                    {
                        display: false//para mostrar los botones del filtrado de los tipos de errores
                    },
                    zoom:
                    {
                        limits:
                        {
                            // x:
                            // {
                            //     min: 'original', max: 'original', minRange: 60 * 1000
                            // },
                        },
                        zoom:
                        {
                            pan:
                            {
                                enabled: true,
                                mode: 'xy',
                            },
                            drag:
                            {
                                enabled: true,
                            },
                            mode: 'x', // Allow zooming in the x direction
                            wheel:
                            {
                                enabled: true,
                                speed: 0.05,
                            },
                            pinch:
                            {
                                enabled: true
                            },
                        },
                    },
                },
            }
        });

        chart.update();
    }

    let filtros='';
    var nombre='';

    $('.casilla').each(function() {
        switch ($(this)[0].value) {
            case '0':
                nombre='LOS';
                break;
            case '1':
                nombre='LOSI';
                break;
            case '2':
                nombre='DYING GASP';
                break;
            case '3':
                nombre='ROUGUE';
                break;
            default:
                // statements_def
                break;
        }
        if($(this).prop('checked')) {
            filtros+=nombre +',';
        }
    });

    filtros=filtros.slice(0, -1);

    var collapsedGroups = {};
    var j=0;
    var oTable = $('#tablalogoids').DataTable({
        dom: 'Blfrtip',
        buttons: [
            { extend: 'csv', text: 'Exportar a CSV', className: ''}
        ],
        orderFixed: {//para ordenar las filas sin romper los contenedores que colapsan las filas
            "pre": [[ 1, 'asc' ], [ 5, 'asc' ]]
        },
        pageLength: 25,
        paging: true,
        language: {
            "decimal": "",
            "emptyTable": "No hay informaci&oacute;n",
            "info": "Mostrando _START_ a _END_ de _TOTAL_ Entradas",
            "infoEmpty": "Mostrando 0 a 0 de 0 Entradas",
            "infoFiltered": "(Filtrado de _MAX_ total entradas)",
            "infoPostFix": "",
            "thousands": ",",
            "lengthMenu": "Mostrar _MENU_ ",
            "loadingRecords": "Cargando...",
            "processing": "Procesando...",
            "search": "Buscar:",
            "zeroRecords": "Sin resultados encontrados",
            "paginate": {
                "first": "Primero",
                "last": "Ultimo",
                "next": "Siguiente",
                "previous": "Anterior"
            },
        },
        order: [
            [1, 'asc']
        ],
        columnDefs: [
            { "orderable": false, "targets": "_all" } // Applies the option to all columns
        ],
        rowGroup:
        {
            // Uses the 'row group' plugin
            dataSrc: 1,
            startRender: function(rows, group) {
                var collapsed = !!collapsedGroups[group];
                rows.nodes().each(function(r) {
                    r.style.display = 'none';
                    if (collapsed)
                    {
                        r.style.display = '';
                    }
                });

                if (rows.nodes()[0].cells[2].firstChild==null)
                {
                    olt='';
                }
                else
                {
                    olt=rows.nodes()[0].cells[2].firstChild.data;
                }

                if (rows.nodes()[0].cells[3].firstChild==null)
                {
                    placa='';
                }
                else
                {
                    placa=rows.nodes()[0].cells[3].firstChild.data;
                }

                if (rows.nodes()[0].cells[4].firstChild==null)
                {
                    puerto='';
                }
                else
                {
                    puerto=rows.nodes()[0].cells[4].firstChild.data;
                }

                valor_ultima_caida=rows.nodes()[0].cells[5].firstChild.data;
                datetime=rows.nodes()[0].cells[6].firstChild.data;

                j++;

                if(j%2==0)
                {
                    clase='trPar';
                }
                else
                {
                    clase='trImpar';
                }
                // Add category name to the <tr>. NOTE: Hardcoded colspan

                if (rows.count()>1)
                {
                    return $('<tr class="remarcado '+clase+' group-start"/> ')
                    .append('<td>'+rows.count()+'<svg class="svgEstilo" xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-down" viewBox="0 0 16 16"><path fill-rule="evenodd" d="M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z"/></svg></td><td>' + group +'</td><td>'+olt+'</td><td>'+placa+'</td><td>'+puerto+'</td><td>'+valor_ultima_caida+' </td><td> '+datetime+' </td>')
                    .attr('data-name', group)
                    .toggleClass('collapsed', collapsed);
                }
                else{
                    return $('<tr class="remarcado '+clase+'" />')
                    .append('<td></td><td>' + group +'</td><td>'+olt+'</td><td>'+placa+'</td><td>'+puerto+'</td><td>'+valor_ultima_caida+' </td><td> '+datetime+' </td>')
                }
            }
        },
        "bDestroy": true
    });

    collapsedGroups = {};
    $('#tablalogoids tbody').off().on('click', 'tr.group-start', function() {
        var name = $(this).data('name');
        collapsedGroups[name] = !collapsedGroups[name];
        oTable.draw(false);
    });

    var actualUrl = window.location.href;
    if (actualUrl.includes("Id"))
    {
        const oltSelect = urlParams.get('Id')
        $("#olt").val(oltSelect)
        $('.buscar_datos').click();
    }
   /*  $('.casilla').on('change', function(e){
      var searchTerms = []
      $.each($('.casilla'), function(i,elem){
        if($(elem).prop('checked')){
          searchTerms.push($(this).val())
        }
      })
      console.log(searchTerms)
      oTable.column(5).search(searchTerms.join('|'), true, false, true).draw();
    });

    $('#olt').on('change', function(e){
        var oltID = $(this).val();
        $('#olt').val(oltID)
        console.log(oltID)
        //dataTable.column(6).search('\\s' + status + '\\s', true, false, true).draw();
        oTable.column(7).search(oltID).draw();
      }) */
})//fin document.ready
