$( document ).ready(function()
{
    function formateaFecha(durationInMinutes) // recibe los minutos y devuelve la hora de inicio
    {
        var startdate = new Date();
        var fecha=startdate.setMinutes(startdate.getMinutes() - durationInMinutes);
        var year=startdate.toLocaleString("default", { year: "numeric" });
        var month=startdate.toLocaleString("default", { month: "2-digit" });
        var day=startdate.toLocaleString("default", { day: "2-digit" });
        var hour=startdate.toLocaleString("default", { hour: "2-digit" });
        var minute=startdate.toLocaleString("default", { minute: "2-digit" });
        minute=("0" + minute).slice(-2);
        var second=startdate.toLocaleString("default", { second: "2-digit" });
        second=("0" + second).slice(-2);
        fecha=year+ "-" + month + "-" +day+" "+hour+":"+minute+":"+second;
        return fecha;
    }

    //función que devuelve a cada bloque la cantidad de alarmas correspondientes a la OLT
    function alarmas15(id_olt)
    {
        durationInMinutes=15;
        fecha15=formateaFecha(durationInMinutes);
        filtro='LOS,LOSI,DYING GASP,ROUGUE';
        var ahora = new Date();//para obtener la fecha actual
        var year=ahora.toLocaleString("default", { year: "numeric" });
        var month=ahora.toLocaleString("default", { month: "2-digit" });
        var day=ahora.toLocaleString("default", { day: "2-digit" });
        var hour=ahora.toLocaleString("default", { hour: "2-digit" });
        var minute=ahora.toLocaleString("default", { minute: "2-digit" });
        minute=("0" + minute).slice(-2);
        var second=ahora.toLocaleString("default", { second: "2-digit" });
        second=("0" + second).slice(-2);
        fecha_fin=year+ "-" + month + "-" +day+" "+hour+":"+minute+":"+second;

        $.ajax({
            url:"/logoid/obtenerLogOidFechas",
            type:'post',
            datatype:'json',
            data:{
                fecha_ini:fecha15,
                fecha_fin:fecha_fin,
                filtro:filtro,
                olt:id_olt
            },
        }).done(function(response)
        {
            $("#ultimasAlarmasOlt"+id_olt).html(JSON.parse(response).length);
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        })
    }

    let olts = <?php echo json_encode($this->olts);?>;
    //CHART.JS NODO SETTINGS
    var oltsReportadas = olts["OLT_REPORTADAS"];
    var oltsSinReportar = olts["OLT_NO_REPORTADAS"];
    console.log("aaa");
    var data = {
        labels: [
            'Reportando',
            'Sin reportar'
        ],
        datasets: [{
            label: '',
            data: [oltsReportadas , oltsSinReportar],//[OLT.CONECTADAS, OLT.DESCONECTADAS]
            backgroundColor: [
                '#006aa6',
                '#ced6db',
            ],
            hoverOffset: 4
        }]
    };

    var options = {
        plugins: {
            legend: {
                display: false
            },
            tooltip:true,
            tooltip: {
                footerColor:"#006aa6",
                yAlign:"left",
                displayColors:false,
                backgroundColor:"#fff",
                callbacks: {
                    title:function(context) {
                        return '';
                    },
                    footer: function(context) {
                        return 'Cantidad: '+context[0].formattedValue;
                    },
                    label: function(context) {
                        return context.dataset.label+context.label;
                    },
                    labelTextColor:function(tooltipItem, chart)
                    {
                        return '#006aa6';
                    },
                }
            }
        },
        spacing:0,
        responsive: true,
        cutout: 70,
    };
    const contextChartNodo = document.getElementById("TotalOlt");

    const chartNodo = new Chart(contextChartNodo, {
        type: "doughnut",
        data,
        options,
        plugins: [{
            beforeInit: function(chart, args, options) {
                // Make sure we're applying the legend to the right chart
                if (chart.canvas.id === "TotalOlt") {
                    const ul = document.createElement('ul');
                    chart.data.labels.forEach((label, i) => {
                        ul.innerHTML += `
                            <li>
                                <span style="background-color: ${ chart.data.datasets[0].backgroundColor[i] }">${ chart.data.datasets[0].data[i] }</span>
                                ${ label }
                            </li>
                        `;
                    });
                    return document.getElementById("nodo-chart-legend").appendChild(ul);
                }
                return;
            }
        }]
    });

    for (let i = 0; i < olts["OLTS"].length; i++) {
        var onusConectadas = olts["OLTS"][i].ONUS_CONECTADAS;
        var onusDesconectadas = olts["OLTS"][i].ONUS_DESCONECTADAS;

        // if (olts[i]["ONUS_CONECTADAS"] != 0) {

        // }

        var data = {
            labels: [
                'Onus Conectadas',
                'Onus Desconectadas'
            ],
            datasets: [{
                label: '',
                data: [onusConectadas, onusDesconectadas],
                backgroundColor: [
                    '#006aa6',
                    '#ced6db'
                ],
                hoverOffset: 4
            }]
        };
        var options = {
            plugins: {
                legend: {
                    display: false
                },
                tooltip:true,
                tooltip: {
                    footerColor:"#006aa6",
                    yAlign:"left",
                    displayColors:false,
                    backgroundColor:"#fff",
                    callbacks: {
                        title:function(context) {
                            return '';
                        },
                        footer: function(context) {
                            return 'Cantidad: '+context[0].formattedValue;
                        },
                        label: function(context) {
                            return context.dataset.label+context.label;
                        },
                        labelTextColor:function(tooltipItem, chart)
                        {
                            return '#006aa6';
                        },
                    }
                }
            },
            spacing:0,
            responsive: true,
            cutout: 70,
        };

        const context = document.getElementById("TotalOnusConectadas"+i);

        if(context){
            const chart = new Chart(context, {
                type: "doughnut",
                data,
                options,
                plugins: [{
                    beforeInit: function(chart, args, options) {
                        // Make sure we're applying the legend to the right chart
                        if (chart.canvas.id === "TotalOnusConectadas"+i) {
                            const ul = document.createElement('ul');
                            chart.data.labels.forEach((label, i) => {
                                ul.innerHTML += `
                                    <li>
                                        <span style="background-color: ${ chart.data.datasets[0].backgroundColor[i] }">${ chart.data.datasets[0].data[i] }</span>
                                        ${ label }
                                    </li>
                                `;
                            });

                            return document.getElementById("js-legend"+i).appendChild(ul);
                        }
                        return;
                    }
                }]
            });
        }
        alarmas15(olts["OLTS"][i]["ID"]);
    }


// ---------------GRAFICO DE POTENCIA //comentado por edu
    console.log(labelArray);
     var graficoPotencia = document.getElementById("potenciaGrafico");
     var myChart = new Chart(graficoPotencia, {
         type: 'bar',
         data: {
             labels:labelArray,
             datasets: [{
                 label: 'Cantidad',
                 data: dataArray,
                 backgroundColor: colorArray,
                 borderRadius: 15,
                 barThickness: 10
             }]
         },
         options: {
             plugins: {
                 legend:
                 {
                     display: false
                 },
                 tooltip:true,
                 tooltip: {
                     yAlign:"bottom",
                     displayColors:true,
                     backgroundColor: "#333",
                     callbacks: {
                         title : function(context) {
                             return 'Potencias';
                         },
                         footer: function(context) {
                             return 'Cantidad: '+context[0].formattedValue;
                         },
                         label: function(context) {
                             return 'Nivel'+': '+context.label;
                         },
                         labelTextColor:function(tooltipItem, chart)
                         {
                             return '#fff';
                         },
                         }
                     }
                 },
                 responsive: true,
                 scales: {
                     y: {ticks: {
                         maxRotation: 90,
                     minRotation: 80
                 },
                 ticks: {
                     beginAtZero: true
                 },
                     grid: {
                     color: 'transparent'
                     }
                 },
                 x: {
                     ticks: {
                         maxRotation: 90,
                         minRotation: 80
                     },
                     grid: {
                     color: 'transparent'
                     }
                 },

             }
         }
     });
     var bars=myChart.data.labels;

     var background=myChart.data.datasets[0].backgroundColor;
     for (i=0;i<bars.length;i++){
         var color="#6eff42";
         if (bars[i]>-13||bars[i]<-26)
         {
             color="#ff4242";
         } else if ((bars[i]>-27&&bars[i]<-24)||((bars[i]>-16&&bars[i]<12))){
             color="#ffbd42"
         }
         else if (bars[i]=='')
         {
             color=grey;
         }
         background[i]=color;
     }
     myChart.update();
// SLIDER BOX OLT SETTINGS

     var swiper = new Swiper(".slide-content", {
         slidesPerView: 4,
         spaceBetween: 25,
         loop: false,
         centerSlide: 'true',
         fade: 'true',
         grabCursor: 'true',
         pagination: {
             el: ".swiper-pagination",
             clickable: true,
             dynamicBullets: true,
         },
         navigation: {
             nextEl: ".swiper-button-next",
             prevEl: ".swiper-button-prev",
         },

         breakpoints:{
             0: {
                 slidesPerView: 1,
             },
             720: {
                 slidesPerView: 2,
             },
             950: {
                 slidesPerView: 3,
             },
         },
     });

     graficoPotencia.onclick = (evt) => {
         const res = myChart.getElementsAtEventForMode(
           evt,
           'nearest',
           { intersect: true },
           true
         );
         //alert('You clicked on ' + myChart.data.labels[res[0].index]);
         var valorRxPower=myChart.data.labels[res[0].index];
         window.open(`/estadooidexterno/diagnostico/search/${valorRxPower}/columna/4`);
     };
});//document
