$( document ).ready(function()
{
    $.ajax({
        url:basepath+"maps/obtenerInfoEstadoOid",
        type:'post',
        dataType:'json',
        async: false
    }).done(function (respuesta)
    {
        let olts=respuesta;

        var oltsReportadas = olts.olts.OLT_REPORTADAS;
        var oltsSinReportar = olts.olts.OLT_NO_REPORTADAS;
        var data = {
            labels: [
                'Reportando',
                'Sin reportar'
            ],
            datasets: [{
                label: '',
                data: [oltsReportadas , oltsSinReportar],//[OLT.CONECTADAS, OLT.DESCONECTADAS]
                backgroundColor: [
                    '#006aa6',
                    '#ced6db',
                ],
                hoverOffset: 4
            }]
        };

        var options = {
            plugins: {
                legend: {
                    display: false
                },
                tooltip:true,
                tooltip: {
                    footerColor:"#006aa6",
                    yAlign:"left",
                    displayColors:false,
                    backgroundColor:"#fff",
                    callbacks: {
                        title:function(context) {
                            return '';
                        },
                        footer: function(context) {
                            return 'Cantidad: '+context[0].formattedValue;
                        },
                        label: function(context) {
                            return context.dataset.label+context.label;
                        },
                        labelTextColor:function(tooltipItem, chart)
                        {
                            return '#006aa6';
                        },
                    }
                }
            },
            spacing:0,
            responsive: true,
            cutout: 70,
        };
        const contextChartNodo = document.getElementById("TotalOlt");

        const chartNodo = new Chart(contextChartNodo, {
            type: "doughnut",
            data,
            options,
            plugins: [{
                beforeInit: function(chart, args, options) {
                    // Make sure we're applying the legend to the right chart
                    if (chart.canvas.id === "TotalOlt") {
                        const ul = document.createElement('ul');
                        chart.data.labels.forEach((label, i) => {
                            ul.innerHTML += `
                                <li>
                                    <span style="background-color: ${ chart.data.datasets[0].backgroundColor[i] }">${ chart.data.datasets[0].data[i] }</span>
                                    ${ label }
                                </li>
                            `;
                        });
                        return document.getElementById("nodo-chart-legend").appendChild(ul);
                    }
                    return;
                }
            }]
        });

        let respuesta_slider='';

        olts.olts.OLTS.forEach(function(valor, indice, array){
            respuesta_slider+=`<div class="card swiper-slide">`;
            if (valor['ULTIMO_REGISTRO']=='') {
                respuesta_slider+=`
                            <div class="olt-no-reportadas">
                                <div class="overlay-no-reportadas"></div>
                                <div class="texto-sin-reportar">
                                    <h2 class="title-sin-reportar"><?php echo lang("SinReportar")?></h2>
                                    <h2>`+valor['NOMBRE']+`</h2>
                                </div>
                            </div>`;
            }
            else
            {
                respuesta_slider+=`
                            <div class="image-content">
                                <div class="card-image">
                                    <div id="prueba_`+indice+`" class="chart chart-appended chart-box-olt">
                                        <div class="js-legend" id="js-legend`+indice+`"></div>
                                        <canvas id="TotalOnusConectadas`+indice+`" class="chart-canvas-olt" data-toggle="legend"
                                            data-target="#TotalOlt" width="316" height="192"
                                            style="display: block; box-sizing: border-box; height: 240px; width: 120px;">
                                        </canvas>
                                    </div>
                                </div>
                            </div>
                            <div class="card-content">`;
                if (valor['NOMBRE']!='')
                {
                    respuesta_slider+=`<h2 id="nombreOlt" class="name">`+valor['NOMBRE']+`</h2>`
                }
                respuesta_slider+=`<div class="ultimo-registro">
                                    <h4 class="description">lang("Uptime")</h4>`;
                if (valor['ULTIMO_REGISTRO']!='')
                {
                    respuesta_slider+=`<p id="ultimoRegistroOlt" class="description">`+valor['ULTIMO_REGISTRO']+`</p>`
                }
                respuesta_slider+=`</div>
                                <div class="ultimas-alarmas">
                                    <h4 class="description">lang("Alarmas15Minutos")</h4>
                                    <p id="ultimasAlarmasOlt" class="description">`+valor['ULTIMAS_ALARMAS']+`</p>
                                </div>
                                <a style="margin-botton:25px;" href="/maps/avanzadaOltMaps/id/`+valor['ID']+`"><p type="button" class="card-button"><?php echo lang("VerMasInfo")?></p></a>
                            </div>`;
            }
            respuesta_slider+=`</div>`;
        })
        $("#swiper-wrapper").html(respuesta_slider);

        for (let i = 0; i < olts.olts.OLTS.length; i++) {
            var onusConectadas = olts.olts.OLTS[i].ONUS_CONECTADAS;
            var onusDesconectadas = olts.olts.OLTS[i].ONUS_DESCONECTADAS;

            var data = {
                labels: [
                    'Onus Conectadas',
                    'Onus Desconectadas'
                ],
                datasets: [{
                    label: '',
                    data: [onusConectadas, onusDesconectadas],
                    backgroundColor: [
                        '#006aa6',
                        '#ced6db'
                    ],
                    hoverOffset: 4
                }]
            };
            var options = {
                plugins: {
                    legend: {
                        display: false
                    },
                    tooltip:true,
                    tooltip: {
                        footerColor:"#006aa6",
                        yAlign:"left",
                        displayColors:false,
                        backgroundColor:"#fff",
                        callbacks: {
                            title:function(context) {
                                return '';
                            },
                            footer: function(context) {
                                return 'Cantidad: '+context[0].formattedValue;
                            },
                            label: function(context) {
                                return context.dataset.label+context.label;
                            },
                            labelTextColor:function(tooltipItem, chart)
                            {
                                return '#006aa6';
                            },
                        }
                    }
                },
                spacing:0,
                responsive: true,
                cutout: 70,
            };

            const context = document.getElementById("TotalOnusConectadas"+i);

            if(context){
                const chart = new Chart(context, {
                    type: "doughnut",
                    data,
                    options,
                    plugins: [{
                        beforeInit: function(chart, args, options) {
                            if (chart.canvas.id === "TotalOnusConectadas"+i) {
                                const ul = document.createElement('ul');
                                chart.data.labels.forEach((label, i) => {
                                    ul.innerHTML += `
                                        <li>
                                            <span style="background-color: ${ chart.data.datasets[0].backgroundColor[i] }">${ chart.data.datasets[0].data[i] }</span>
                                            ${ label }
                                        </li>
                                    `;
                                });
                                return document.getElementById("js-legend"+i).appendChild(ul);
                            }
                            return;
                        }
                    }]
                });
            }
        }
    })
    .fail(function(jqXHR,textStatus,errorThrown)
    {
        console.log(jqXHR+textStatus+errorThrown);
    });

// ---------------GRAFICO DE POTENCIA

    var graficoPotencia = document.getElementById("potenciaGrafico");

    var myChart = new Chart(graficoPotencia, {
        type: 'bar',
        data: {
            labels:labelArray,
            datasets: [{
                label: 'Cantidad',
                data: dataArray,
                backgroundColor: colorArray,
                borderRadius: 15,
                barThickness: 10
            }]
        },
        options: {
            plugins: {
                legend:
                {
                    display: false
                },
                tooltip:true,
                tooltip: {
                yAlign:"bottom",
                displayColors:true,
                backgroundColor: "#333",
                callbacks: {
                    title : function(context) {
                        return 'Potencias';
                    },
                    footer: function(context) {
                        return 'Cantidad: '+context[0].formattedValue;
                    },
                    label: function(context) {
                        return 'Nivel'+': '+context.label;
                    },
                    labelTextColor:function(tooltipItem, chart)
                    {
                        return '#fff';
                    },
                }
            }
            },
            responsive: true,
            scales: {
                y: {
                    ticks: {
                        maxRotation: 90,
                        minRotation: 80
                    },
                    ticks: {
                        beginAtZero: true
                    },
                    grid: {
                        color: 'transparent'
                    }
                },
                x: {
                    ticks: {
                        maxRotation: 90,
                        minRotation: 80
                    },
                    grid: {
                        color: 'transparent'
                    }
                },

            }
        }
    });
    var bars=myChart.data.labels;

    var background=myChart.data.datasets[0].backgroundColor;
    for (i=0;i<bars.length;i++){
        var color="#6eff42";
        if (bars[i]>-13||bars[i]<-26)
        {
            color="#ff4242";
        } else if ((bars[i]>-27&&bars[i]<-24)||((bars[i]>-16&&bars[i]<12))){
            color="#ffbd42"
        }
        else if (bars[i]=='')
        {
            color=grey;
        }
        background[i]=color;
    }
    myChart.update();
// SLIDER BOX OLT SETTINGS

    var swiper = new Swiper(".slide-content", {
        slidesPerView: 4,
        spaceBetween: 25,
        loop: false,
        centerSlide: 'true',
        fade: 'true',
        grabCursor: 'true',
        pagination: {
            el: ".swiper-pagination",
            clickable: true,
            dynamicBullets: true,
        },
        navigation: {
            nextEl: ".swiper-button-next",
            prevEl: ".swiper-button-prev",
        },

        breakpoints:{
            0: {
                slidesPerView: 1,
            },
            720: {
                slidesPerView: 2,
            },
            950: {
                slidesPerView: 3,
            },

        },
    });

    graficoPotencia.onclick = (evt) => {
        const res = myChart.getElementsAtEventForMode(
          evt,
          'nearest',
          { intersect: true },
          true
        );
        //alert('You clicked on ' + myChart.data.labels[res[0].index]);
        var valorRxPower=myChart.data.labels[res[0].index];
        window.open(`/estadooid/diagnostico/search/${valorRxPower}/columna/4`);
    };
});//document
