var map;
var arrayCoordenadasTroncal=[];
var arrayCoordenadasBotellas=[];
var arrayCoordenadasSubTroncal=[];

function initMap()
{
    const coordenadasArgentina = {lat: -34.7315752, lng: -58.2881474};

    map = new google.maps.Map(document.getElementById("map"),{
        center: coordenadasArgentina, //Coordenadas de Argentina
        zoom: 17,
        mapTypeId: google.maps.MapTypeId.ROADMAP
    });

        // Create the search box and link it to the UI element.
        const input = document.getElementById("inputMap");
        const searchBox = new google.maps.places.SearchBox(input);

        map.controls[google.maps.ControlPosition.TOP_LEFT].push(input);
        // Bias the SearchBox results towards current map's viewport.
        map.addListener("bounds_changed", () => {
            searchBox.setBounds(map.getBounds());
        });

        let markers = [];

        // Listen for the event fired when the user selects a prediction and retrieve
        // more details for that place.
        searchBox.addListener("places_changed", () => {
        const places = searchBox.getPlaces();

        if (places.length == 0)
        {
          return;
        }

        // Clear out the old markers.
        markers.forEach((marker) => {
            marker.setMap(null);
        });
        markers = [];

        // For each place, get the icon, name and location.
        const bounds = new google.maps.LatLngBounds();

        places.forEach((place) => {
            if (!place.geometry || !place.geometry.location) {
            console.log("Returned place contains no geometry");
            return;
        }

        const icon = {
            url: place.icon,
            size: new google.maps.Size(71, 71),
            origin: new google.maps.Point(0, 0),
            anchor: new google.maps.Point(17, 34),
            scaledSize: new google.maps.Size(25, 25),
        };
          // Create a marker for each place.
        markers.push(
            new google.maps.Marker({
                map,
                icon,
                title: place.name,
                position: place.geometry.location,
            })
        );
        if (place.geometry.viewport)
        {
        // Only geocodes have viewport.
            bounds.union(place.geometry.viewport);
        }
        else
        {
            bounds.extend(place.geometry.location);
        }
        });
            map.fitBounds(bounds);
        });

}//InitMap

window.initMap = initMap;


function btnUbicarBotellas()
{
    //Dibujando la troncal
    poly = new google.maps.Polyline({
        strokeColor: "#343C34",
        strokeOpacity: 1.0,
        strokeWeight: 0,
    });

    poly.setMap(map);

    map.addListener("click", addLatLng); //Llama a la funcion del evento

    function addLatLng(event) // Evento que al hacer click obtiene la coordenadas
    {
        //Modal completar formulario de caja de empalme
        $('#cajaEmpalmeModal').show();
        var latitudCoor='', longitudCoor='';

        //GUARDAR TODOS LOS DATOS DE LA CAJA DE EMPALME
        const path = poly.getPath();
        // Because path is an MVCArray, we can simply append a new coordinate
        // and it will automatically appear.
        path.push(event.latLng);

        var vMarker = new google.maps.Marker({
        position: event.latLng,
        map: map,
        icon: '../mvc/imagenes/sangrado.png',
        });

        latitudCoor = event.latLng.lat().toFixed(6);
        longitudCoor = event.latLng.lng().toFixed(6);

        arrayCoordenadasBotellas.push({"latitud": latitudCoor, "longitud": longitudCoor});

        $('#btnGuardarDatosCajaEmpalme').click(function()
        {
            $('#cajaEmpalmeModal').hide();

            $('#btnGuardarDatosCajaEmpalme').click(function(){
                $('nombreCajaEmpalme').val();
            });
        });

        $('#btnCancelarDatosCajaEmpalme').click(function()
        {
            $('#cajaEmpalmeModal').hide();
        });
    }
}

function btnDibujarTrocal()
{
    dibujoGeneral('black',3,'../mvc/imagenes/poste.png',arrayCoordenadasTroncal);
}

function btnDibujarsubTrocal()
{
    dibujoGeneral('red',4,'',arrayCoordenadasSubTroncal);
}

/*
    Function generica dibuja y obtiene las coordenadas
*/
function dibujoGeneral(colorLinea, grosorLinea, urlIconoMaker,arrayCoordenadas)
{
    //Dibujando la troncal
    poly = new google.maps.Polyline({
        strokeColor: colorLinea,
        strokeOpacity: 1.0,
        strokeWeight: grosorLinea,
    });
    poly.setMap(map);

    map.addListener("click", (event)=>{ //evento

        const path = poly.getPath();
        // Because path is an MVCArray, we can simply append a new coordinate
        // and it will automatically appear.
        path.push(event.latLng);

        var vMarker = new google.maps.Marker({
            position: event.latLng,
            map: map,
            icon: urlIconoMaker,
        });

        latitudCoor = event.latLng.lat().toFixed(6);
        longitudCoor = event.latLng.lng().toFixed(6);

        arrayCoordenadas.push({"lat": latitudCoor, "lng": longitudCoor});

    });

    // Evento que al hacer click obtiene la coordsenadas
    map.setCenter(vMarker.position);
    // adds the marker on the mapc
    vMarker.setMap(map);
}


$(document).ready(function()
{
    //Obteniendo nodo
    $.ajax({
        url:"/factibilidad/datosNodo",
        type:'post',
        datatype:'json',
        data:{},
    }).done(
    function(respuesta)
    {
        var datos = JSON.parse(respuesta);
        console.log(datos);
        /*
        if(respuesta!="")
        {
            var datos=JSON.parse(respuesta);
            var coordenadas, marker, circuloOlt;

            $.each(datos, function (i, item)
            {
                valorLat=item.LATITUD;
                valorLng=item.LONGITUD;
                nombreNodo=item.NOMBRE;

                coordenadas={lat: valorLat, lng: valorLng};

                maker(coordenadas,'../mvc/imagenes/nodo.png','Nodo Principal',false);//llamada a function

                circuloFiguraRadius(coordenadas,0,"#066175",0.5, "#33FF86"); //llamada a function

                var html =
                    "<div class='container text-center'>" +
                        "<h6 class='tituloInfoMaps'>Nodo: " + nombreNodo + "</h6>"+
                        "<br>"+
                        "<strong class='parrafo-infoMaps'> Latitud: " + valorLat + " " + "Longitud: " + valorLng + "</strong>"+
                    "</div>";

                var infowindow = new google.maps.InfoWindow({
                    content: html,
                });

                //infowindow.open(map,marker);
                google.maps.event.addListener(marker, 'click', function()
                {
                    infowindow.open(map,marker);
                });
            });//each
        }
        else
        {
            alert("No existe Nodo");
        }
        */
    })
    .fail(function (jqXHR, textStatus, errorThrown){
        alert("" + jqXHR + textStatus +errorThrown);
    });

    //-------------------------------------------------------TRONCAL-----------------------------------------------
    /*--DATOS PARA FORMULARIO*/
    /*------------------------------------
        Obtengo los colores del pelo fibra
    ------------------------------------**/
    $.ajax({
        url:"/factibilidad/colorFibra",
        type:'post',
        datatype:'json',
        data:{
        },
    }).done(
    function(respuesta)
    {
        var datosColoresDeFibras=JSON.parse(respuesta);
        for (var i=0; i<datosColoresDeFibras.length; i++)
        {
            var idColor=datosColoresDeFibras[i]['ID_COLORPELOFIBRA'];
            var color=datosColoresDeFibras[i]['COLOR'];
            var codigo=datosColoresDeFibras[i]['CODIGO'];
            $('.colorDeFibraTroncal').append("<option value='" + idColor + "' style='color: white; font-size:20px; background-color: " + codigo + "'>" + color + "</option>");
        }
    })
    .fail(function (jqXHR, textStatus, errorThrown){
    alert("" + jqXHR + textStatus +errorThrown);
    });

    /*--------------------------------
        Obtengo los colores del buffer
    ---------------------------------**/
    $.ajax({
        url:"/factibilidad/colorBuffer",
        type:'post',
        datatype:'json',
        data:{
        },
    }).done(
    function(respuesta)
    {
        var datosColorBuffer=JSON.parse(respuesta);

        for (var i=0; i<datosColorBuffer.length; i++)
        {
            var idColorBuffer=datosColorBuffer[i]['ID_COLOR_BUFFER_FIBRA'];
            var color=datosColorBuffer[i]['COLOR'];
            var codigo=datosColorBuffer[i]['CODIGO'];
            $('.colorDeBuffer').append("<option value='" + idColorBuffer + "' style='color: white; font-size:20px; background-color: " + codigo + "'>" + color + "</option>");
        }
    })
    .fail(function (jqXHR, textStatus, errorThrown){
    alert("" + jqXHR + textStatus +errorThrown);
    });

    /**------------------------------
        Obtengo el tipo de fibra
    -------------------------------*/
    $.ajax({
        url:"/factibilidad/tipoDeFibra",
        type:'post',
        datatype:'json',
        data:{
        },
    }).done(
    function(respuesta)
    {
        var datosTipoFibra=JSON.parse(respuesta);
        for (var i=0; i<datosTipoFibra.length; i++)
        {
            var idTipoFibra=datosTipoFibra[i]['ID'];
            var nombrefibra=datosTipoFibra[i]['NOMBRE'];

            $( "#tipoDeFibra" ).append( "<option class='colorOption' value='" + idTipoFibra + "'>" + nombrefibra +"</option>");
        }
    })
    .fail(function (jqXHR, textStatus, errorThrown){
    alert("" + jqXHR + textStatus +errorThrown);
    });

    //TRONCAL

    /*-------------------------------------
    GUARDADO DE COORDENADAS TRONCAL
    --------------------------------------*/
    $('#btnGuardarTroncal').click(function()
    {
        //var coordenadas = {"coordenadas" : arrayCoordenadasTroncal};
        var jsonCoordenadas = JSON.stringify(arrayCoordenadasTroncal);

console.log(arrayCoordenadasTroncal);

        $.ajax({
            url:"/factibilidad/altaDatosTroncal",
            type:'post',
            datatype:'json',
            data:{
                jsonCoordenadas_: jsonCoordenadas,
                nombreTroncal_: $('#nombreTroncal').val(),
                cantidadDePelos_: $('#cantidadDePelos').val(),
                modeloFibra_: $('#modeloFibra').val(),
                colorDeFibra_: $('#colorDeFibraTroncal').val(),
                colorBuffer_: $('#colorDeBuffer').val(),
                tipoDeFibra_: $('#tipoDeFibra').val()
            },
        }).done(
        function(respuesta)
        {
            alert("Guardado del troncal con exito!");
            //location.reload();
            //Bloqueo del boton dibujar troncal
            $('#btnDibujarTroncal').prop('disabled', true);
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    });

    /**----------------------------------
        LISTANDO (TRONCAL CON SUS MAKERS)
    ------------------------------------*/
    var arrayCoor=[];
    var arrayNuevasCoordenadasTroncalModificada=[];
    $('#btnModificarTroncal').prop('disabled', true);
    $('#btnGuardarModificarTroncal').prop('disabled', true);
    $('#btnEliminarTroncal').prop('disabled',true);

    $('#btnListarTroncal').click(function()
    {
        $.ajax({
            url:"/factibilidad/datosTroncal",
            type:'post',
            datatype:'json',
            data:{},
        }).done(
        function(respuesta)
        {
            $('#btnListarTroncal').prop('disabled',true);
            $('#btnModificarTroncal').prop('disabled', false);
            $('#btnGuardarModificarTroncal').prop('disabled', false);
            $('#btnEliminarTroncal').prop('disabled',false);

            var datosCoordenadasTroncal=JSON.parse(respuesta);

            $.each(datosCoordenadasTroncal, function (i, item)
            {
                $.each(item, function (a, b)
                {
                    b=JSON.parse(b);
                    $.each(b, function (c, d)
                    {
                        var lat= d.lat;
                        var latitudd = parseFloat(lat);
                        var long= d.lng;
                        var longitudd = parseFloat(long);

                        //console.log(latitudd);

                        var coordenadas = {lat: latitudd, lng: longitudd};

                        var tituloMaker = latitudd + " " + longitudd;
                        maker(coordenadas,'../mvc/imagenes/poste.png',tituloMaker); //Llamada function

                        arrayCoor.push({lat: latitudd, lng: longitudd});
                        arrayNuevasCoordenadasTroncalModificada.push({lat: lat, lng: long});
                    });
                });
            });

            poly = new google.maps.Polyline({
                path:  arrayCoor,
                strokeColor: "#5B5B5B",
                strokeOpacity: 1.0,
                strokeWeight: 3,
            });

            poly.setMap(map);
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    });//btn listar troncal

    /*----------------------------------------------------------------------------
        MODIFICAR TRONCAL (Guarda los puntos que continuo trazando en la troncal)
    ----------------------------------------------------------------------------*/
    $('#modalAlertaModificarTroncal').hide();
    $('#btnModificarTroncal').click(function()
    {
        $('#modalAlertaModificarTroncal').show();
        $('#btnCerrarModalAlertaModificarTroncal').click(function()
        {
            $('#modalAlertaModificarTroncal').hide();
        });
        //Indico donde termina la troncal (para que el cliente sepa donde tiene que seguir trazando)
        var ultimaCoordenada = arrayCoor[arrayCoor.length-1]; //Ultima posicion

        for(i in ultimaCoordenada)
        {
            var latitud = parseFloat(ultimaCoordenada.lat);
            var longitud = parseFloat(ultimaCoordenada.lng);
            var coordenadas = {lat : latitud , lng: longitud};

            const circuloOlt = new google.maps.Circle({
                center: coordenadas,
                radius: 10,
                strokeColor: 'red',
                strokeWeight:1,
                fillColor: 'red',
                fillOpacity:0.2

            });
            circuloOlt.setMap(map);
        }

        //---------------------Dibujando la troncal
        poly = new google.maps.Polyline({
            path: arrayCoor,
            strokeColor: "#343C34",
            strokeOpacity: 1.0,
            strokeWeight: 3,
        });

        poly.setMap(map);

        map.addListener("click", addLatLng);


        var vMarker="";

        function addLatLng(event)
        {
            const path = poly.getPath();

            path.push(event.latLng);

            vMarker = new google.maps.Marker({
                position: event.latLng,
                map: map,
                icon: '../mvc/imagenes/poste.png',
            });

            latitudCoor = event.latLng.lat().toFixed(6);
            longitudCoor = event.latLng.lng().toFixed(6);

            arrayNuevasCoordenadasTroncalModificada.push({"lat": latitudCoor, "lng": longitudCoor});
        }

        map.setCenter(vMarker.position);

        //vMarker.setMap(map);
    });

    /*-----------------------------------
        GUARDAR TRONCAL MODIFICADA
    ------------------------------------*/
    $('#btnGuardarModificarTroncal').click(function()
    {
        var jsonCoordenadasTroncalModificadas = JSON.stringify(arrayNuevasCoordenadasTroncalModificada);
        $.ajax({
            url:"/factibilidad/modificarTroncalPrincipal",
            type:'post',
            datatype:'json',
            data:{
                jsonCoordenadasTroncalModificadas_: jsonCoordenadasTroncalModificadas,
                /*
                nombreTroncal_: $('#nombreTroncal').val(),
                cantidadDePelos_: $('#cantidadDePelos').val(),
                modeloFibra_: $('#modeloFibra').val(),
                colorDeFibra_: $('#colorDeFibraTroncal').val(),
                colorBuffer_: $('#colorDeBuffer').val(),
                tipoDeFibra_: $('#tipoDeFibra').val()
                */
            },
        }).done(
        function(respuesta)
        {
            alert("Se modifico la troncal con exito!");
            location.reload();
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    });

    /*-----------------------------------
        ELIMINO TRONCAL COMPLETA
    -----------------------------------*/
    $("#btnEliminarTroncal").click(function()
    {
        $.ajax({
            url:"/factibilidad/eliminarTroncal",
            type:'post',
            datatype:'json',
            data:{},
        }).done(
        function(respuesta)
        {
            alert("Troncal eliminada con exito!");
            location.reload();

        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    });//btn eliminar troncal

    /*----------------------------------
        BOTELLA (Agregando a la troncal)
    -----------------------------------*/
    $('#btnGuardarTroncalBotellas').click(function()
    {
        var jsonCoordenadasBotellas = JSON.stringify(arrayCoordenadasBotellas);

        $.ajax({
            url:"/factibilidad/agregarBotella",
            type:'post',
            datatype:'json',
            data:{
                JsonCoordenadasBotella_: jsonCoordenadasBotellas,
            },
        }).done(
        function(respuesta)
        {
            console.log(respuesta);
            //alert("Guardado de cajas de empalme con exito!");
            //location.reload();
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    });

    /*---------------------------------
        LISTADO DE BOTELLAS
    ---------------------------------*/
    $('#btnListarBotellas').click(function()
    {
        $.ajax({
            url:"/factibilidad/listarBotellas",
            type:'post',
            datatype:'json',
            data:{},
        }).done(
        function(respuesta)
        {
            var datos = JSON.parse(respuesta);

            for(i in datos)
            {
                var latitud = parseFloat(datos[i].latitud);
                var longitud = parseFloat(datos[i].longitud);

                var coordenadas = {lat: latitud, lng: longitud};

                var tituloCoorBotellas = "Lat: " + latitud + " Long:" + longitud;
                var makerr=maker(coordenadas,'../mvc/imagenes/sangrado.png', tituloCoorBotellas); //call

                info_CajaDeEmpalme(makerr);//call
            }
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });

    });//btn 2

    /*----------------------------
        ALTA SUBTRONCAL
    -----------------------------*/
    $('#btnGuardarsubTroncal').click(function()
    {
        //var coordenadas = {"coordenadas" : arrayCoordenadasTroncal};
        var jsonCoordenadasSubTroncal = JSON.stringify(arrayCoordenadasSubTroncal);
console.log(arrayCoordenadasSubTroncal);

        $.ajax({
            url:"/factibilidad/altaDatosSubTroncal",
            type:'post',
            datatype:'json',
            data:{
                jsonCoordenadasSubTroncal_: jsonCoordenadasSubTroncal,
                //Falta todos los demas datos de la subtroncal
            },
        }).done(
        function(respuesta)
        {
            alert("Guardado del subTroncal con exito!");
            //location.reload();
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    });

    /*----------------------------
        LISTAR SUBTRONCAL
    -----------------------------*/
    var arrayCoorSubTroncal=[];
    $('#btnListarSubTroncal').click(function()
    {
        $.ajax({
            url:"/factibilidad/obteniendoDatosSubtroncal",
            type:'post',
            datatype:'json',
            data:{},
        }).done(
        function(respuesta)
        {
            var datosCoordenadasTroncal=JSON.parse(respuesta);

            //console.log(datosCoordenadasTroncal);
            $.each(datosCoordenadasTroncal, function (i, item)
            {
                $.each(item, function (a, b)
                {
                    b=JSON.parse(b);
                    $.each(b, function (c, d)
                    {
                        var lat= d.latitud;
                        var latitudd = parseFloat(lat);
                        var long= d.longitud;
                        var longitudd = parseFloat(long);

                        //console.log(latitudd);

                        var coordenadas = {lat: latitudd, lng: longitudd};

                        var makerr=maker(coordenadas,'../mvc/imagenes/'); //Llamada function

                        console.log(makerr);

                        arrayCoorSubTroncal.push({lat: latitudd, lng: longitudd})
                    });
                });
            });

            poly = new google.maps.Polyline({
                path:  arrayCoorSubTroncal,
                strokeColor: "red",
                strokeOpacity: 1.0,
                strokeWeight: 2,
            });

            poly.setMap(map);
        })
        .fail(function (jqXHR, textStatus, errorThrown){
            alert("" + jqXHR + textStatus +errorThrown);
        });
    });//btn listar troncal

    //--------------------------------------------Funciones google maps---------------------------------
    function maker(coordenadas,rutaImagen,tituloMaker,estadoDraggable=false)
    {
        marker=new google.maps.Marker({
            position: coordenadas,
            map,
            icon: rutaImagen,
            title: tituloMaker,
            draggable: estadoDraggable,
        });
        return marker;
    }

    function circuloFiguraRadius(coordenadas,tamanioRadius,colorBordeRadius,transparenciaRadius,colorFondoRadius)
    {
        const circuloOlt = new google.maps.Circle({
            center: coordenadas,
            radius: tamanioRadius,
            strokeColor: colorBordeRadius,
            strokeOpacity: transparenciaRadius,
            strokeWeight:1,
            fillColor: colorFondoRadius,
            fillOpacity:0.2
        });

        circuloOlt.setMap(map);
    }

    /**
        FUE CREADA PARA MOSTRAR MESAJES EN LOS ICONOS DE LA CAJA DE EMPALME
    */
    function info_CajaDeEmpalme(makerr)
    {
        var html =
        "<div class='container text-center p-2'>" +
            "<h6 clss='text-center'>CAJA EMPALME </h6>"+
            "Color de pelos fusionados: rojo y azul"+
            "<br><button id='btnCajaCreada' class='btn btn-primary mt-4 col-12'>Ver mas</button>"
        "</div>";

        var infowindow = new google.maps.InfoWindow({
            content: html,
        });

        google.maps.event.addListener(makerr, 'click', function()
        {
            infowindow.open(map,makerr);
        });
    }


});//Document